<?php
/**
 *  WordPress widget sidebar
 */

if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'before_widget' => '',
        'after_widget' => '',
        'before_title' => '<div class="title">',
        'after_title' => '</div>',
    ));
	
	//following code from http://bavotasan.com - many thanks
	function getImage($num) {  
	global $more;  
	$more = 1;  
	$link = get_permalink();  
	$content = get_the_content();  
	$count = substr_count($content, '<img');  
	$start = 0;  
	for($i=1;$i<=$count;$i++) {  
	$imgBeg = strpos($content, '<img', $start);  
	$post = substr($content, $imgBeg);  
	$imgEnd = strpos($post, '>');  
	$postOutput = substr($post, 0, $imgEnd+1);  
	$postOutput = preg_replace('/width="([0-9]*)" height="([0-9]*)"/', '',$postOutput);;  
	$image[$i] = $postOutput;  
	$start=$imgEnd+1;  
	}  
	if(stristr($image[$num],'<img')) { echo '<a href="'.$link.'">'.$image[$num]."</a>"; }  
	$more = 0;  
	} 

/**
 * Snippets Function File
 *
 * LICENSE: The GNU General Public License (GPL)
 *
 * @copyright  2009 Business Xpand
 * @license    GPL v2.0
 * @version    1.0
 * @link       http://www.businessxpand.com
 * @since      File available since Release 1.0
*/

/**
 * Update your snippet fields here
 *
 * INSTRUCTIONS:
 * - Array key (value before the => is only for the purposes of the admin system.
 * - Array value (value after the => is the field name.
 *
 * - To use the value of the snippet in your theme call the following function:
 *   <?php snippet('field_name'); ?>
 *   where the 'field_name' is the array value you entered below.
 *   
*/
$snippetFields = array('Twitter username' => 'username',
                       'Number of tweets to show' => 'tweets',
											 'Theme Logo' => 'theme_logo');
											 
$default_logo = 'theme-logo.png'; // Change this to edit the default logo for the site (just change the file extension if you can)

/** DO NOT CHANGE ANYTHING BELOW THIS LINE */

/**
 * Output snippet field value
 *
 * @param string $fieldName
 * @return stdout
 */
function snippet($fieldName) {
    if (isset($fieldName)) {
        $snippetOptions = get_option('snippets');
        if (isset($snippetOptions[$fieldName])) echo $snippetOptions[$fieldName];
    }   
}

/**
 * Processing for the snippet theme admin page
 *
 * @param null
 * @return void
 */
function snippetsAddThemePage() {
    global $snippetFields;
		
		wp_enqueue_script('ajax_upload',
									 get_bloginfo('stylesheet_directory') . '/ajaxupload.3.5.js',
									 array( 'jquery' ) );
									 
		wp_enqueue_script( 'thickbox' );
		wp_enqueue_style( 'thickbox' );
		
    if (isset($_GET['page']) && ($_GET['page']==basename(__FILE__))) {
        if (isset($_REQUEST['action']) && ('save'==$_REQUEST['action'])) {
            check_admin_referer('snippets-nonce');
            if (isset($_REQUEST['snippetsform'])) {
    						delete_option('snippets');
                foreach ($snippetFields as $dummy => $snippetField) {
                    if (isset($_REQUEST[$snippetField])) $snippetOptions[$snippetField] = $_REQUEST[$snippetField];
                }
                add_option('snippets', $snippetOptions);
            }
            wp_redirect("themes.php?page=functions.php&saved=true");
            die;
        }
    }
    add_theme_page('Snippets', 'Snippets', 'edit_themes', basename(__FILE__), 'snippetsThemePage');
}
add_action('admin_menu', 'snippetsAddThemePage');

/**
 * Output the snippet theme admin page
 *
 * @param null
 * @return void
 */
function snippetsThemePage() {
    global $snippetFields, $default_logo;
    $snippetOptions = get_option('snippets');
		$upload_abs_path = get_option('upload_path');
		$upload_path = get_bloginfo( 'siteurl' ) . '/' . str_replace(ABSPATH, '', get_option('upload_path'));
		
    if (isset($_REQUEST['saved'])) echo '<div id="message" class="updated fade"><p><strong>'.__('Snippet values saved.').'</strong></p></div>';
?>
<div class='wrap'>
		<script type="text/javascript">
			jQuery(document).ready(function(){
			
				/* example3 */
				new AjaxUpload('#button3', {
					action: '<?php echo get_bloginfo('stylesheet_directory'); ?>/image_upload.php',
					name: 'flash_image',
					onSubmit : function(file, data){
						jQuery('#upload_message').html('<img src="<?php echo get_bloginfo('stylesheet_directory'); ?>/loading.gif" align="middle"/> uploading image...');
					},
					onComplete : function(file, data){
						var split_data = data.split("-:-");
												
						if(split_data[0] == 'Success') {
							jQuery('<li></li>').appendTo(jQuery('.files')).html("<input type='radio' name='theme_logo' value='<?php echo $upload_path . '/'; ?>" +  split_data[1] + "'/>&nbsp;" +  split_data[1] + "<a href='<?php echo get_bloginfo( 'stylesheet_directory' ); ?>/images/" +  split_data[1] + "' class='thickbox thickbox-preview'> [view]</a>");
							jQuery('#upload_message').html('"' + file + '" has been successfully uploaded and renamed to "' +  split_data[1] + '"');
							tb_init('a.thickbox, area.thickbox, input.thickbox'); // To include newly created image preview link
						}
						else {
							jQuery('#upload_message').html(data);
						}
					}	
				});		
			
			});
		</script>
    <h2>Snippets</h2>
    <div>
        <form method="post" action="">
            <?php wp_nonce_field('snippets-nonce'); ?>
            <input type="hidden" name="action" value="save"/>
            <input type="hidden" name="snippetsform" value="true"/>
            <table class="form-table">
                <tbody>
                    <?php foreach ($snippetFields as $name => $snippetField) { 
														if($name != 'Theme Logo') { ?>
                    <tr valign="top">
                        <th scope="row"><label for="<?php echo $snippetField; ?>"><?php echo $name; ?></label></th>
                        <td><input type="text" id="<?php echo $snippetField; ?>" name="<?php echo $snippetField; ?>" value="<?php echo (isset($snippetOptions[$snippetField]) ? $snippetOptions[$snippetField] : ''); ?>"/></td>
                    </tr>
                    <?php 	}
													} ?>
										<tr valign="top">
											<th scope="row"><label>Theme Logo</label></th>
											<td>
												<ul class="files">
													<li><input type="radio" name="theme_logo" value="<?php echo get_bloginfo( 'stylesheet_directory' ) . '/images/' . $default_logo; ?>"<?php echo ( strstr( $snippetOptions['theme_logo'], $default_logo ) !== false ? 'checked = "checked"' : ''); ?>/>&nbsp; <?php echo $default_logo . '&nbsp;' . $file; ?><a href= "<?php echo get_bloginfo( 'stylesheet_directory' ) . '/images/' . $default_logo; ?>" class="thickbox thickbox-preview">[view]</a></li>
												<?php 
												
												if ($handle = opendir( $upload_abs_path ) ) {
												
														while (false !== ($file = readdir($handle))) {
																if(substr($file, 0, 10) == 'theme-logo') {
																	echo '<li><input type="radio" name="theme_logo" value="' . $upload_path . '/' . $file . '" ' . ( strstr( $snippetOptions['theme_logo'], $file ) !== false ? 'checked = "checked"' : '') .'/>&nbsp;' . $file . ' <a href= "' . $upload_path . '/' . $file . '" class="thickbox thickbox-preview">[view]</a></li>' . "\r\n";
																}
														}
														closedir($handle);
												}
												?>
												</ul>
											</td>
										</tr>
										<tr valign="top">
											<th scope="row"><label>Upload new logo</label></th>
											<td>
													<input type="file" id="button3" class=""/>
											</td>
										</tr>
										<tr valign="top">
											<th scope="row"></th>
											<td id="upload_message">
											</td>
										</tr>
                </tbody>
            </table>
            <p class="submit"><input class="button-primary" type="submit" name="submit" value="Save Changes"/></p>
        </form>
    </div>
</div>
<?php } ?>